/*
 * Created on 03-Feb-2004
 */
package dk.eclipse.sablecceditor;

import org.eclipse.ui.plugin.*;
import org.eclipse.core.runtime.*;
import org.eclipse.core.resources.*;

import java.util.*;

/**
 * @author Pieter van der Spek
 * @version 1.0.0
 * 
 * The main plugin class
 */
public class SableccEditorPlugin extends AbstractUIPlugin {

	/** The id of the Overture editor plugin
	 * (value <code>"org.overture.eclipse.editor"</code>). */	
	public static final String PLUGIN_ID = "dk.eclipse.sablecceditor";
	
	//The shared instance.
	private static SableccEditorPlugin plugin;
	//Resource bundle.
	private ResourceBundle resourceBundle;

	/**
	 * The constructor.
	 */
	public SableccEditorPlugin(IPluginDescriptor descriptor) {
		super(descriptor);
		plugin = this;
		try {
			resourceBundle =
			ResourceBundle.getBundle(PLUGIN_ID + ".plugin");
		} catch (MissingResourceException x) {
			resourceBundle = null;
		}
	}
	
	/**
	 * Returns the shared instance of the Plugin.
	 */
	public static SableccEditorPlugin getDefault() {
		return plugin;
	}

	/**
	 * Returns the workspace instance.
	 */
	public static IWorkspace getWorkspace() {
		return ResourcesPlugin.getWorkspace();
	}

	/**
	 * Returns the string from the plugin's resource bundle,
	 * or 'key' if not found.
	 */
	public static String getResourceString(String aKey) {
		String bundleString;
		ResourceBundle bundle = getDefault().getResourceBundle();
		if (bundle != null) {
			try {
				bundleString = bundle.getString(aKey);
			} catch (MissingResourceException e) {
				bundleString = aKey;
			}
		} else {
			bundleString = aKey;
		}
		return bundleString;
	}

	/**
	 * Returns the plugin's resource bundle,
	 */
	public ResourceBundle getResourceBundle() {
		return resourceBundle;
	}
}
